// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from mapviz_interfaces:srv/AddMapvizDisplay.idl
// generated code does not contain a copyright notice
#include "mapviz_interfaces/srv/add_mapviz_display__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

// Include directives for member types
// Member `name`
// Member `type`
#include "rosidl_generator_c/string_functions.h"
// Member `properties`
#include "marti_common_msgs/msg/key_value__functions.h"

bool
mapviz_interfaces__srv__AddMapvizDisplay_Request__init(mapviz_interfaces__srv__AddMapvizDisplay_Request * msg)
{
  if (!msg) {
    return false;
  }
  // name
  if (!rosidl_generator_c__String__init(&msg->name)) {
    mapviz_interfaces__srv__AddMapvizDisplay_Request__fini(msg);
    return false;
  }
  // type
  if (!rosidl_generator_c__String__init(&msg->type)) {
    mapviz_interfaces__srv__AddMapvizDisplay_Request__fini(msg);
    return false;
  }
  // draw_order
  // visible
  // properties
  if (!marti_common_msgs__msg__KeyValue__Sequence__init(&msg->properties, 0)) {
    mapviz_interfaces__srv__AddMapvizDisplay_Request__fini(msg);
    return false;
  }
  return true;
}

void
mapviz_interfaces__srv__AddMapvizDisplay_Request__fini(mapviz_interfaces__srv__AddMapvizDisplay_Request * msg)
{
  if (!msg) {
    return;
  }
  // name
  rosidl_generator_c__String__fini(&msg->name);
  // type
  rosidl_generator_c__String__fini(&msg->type);
  // draw_order
  // visible
  // properties
  marti_common_msgs__msg__KeyValue__Sequence__fini(&msg->properties);
}

mapviz_interfaces__srv__AddMapvizDisplay_Request *
mapviz_interfaces__srv__AddMapvizDisplay_Request__create()
{
  mapviz_interfaces__srv__AddMapvizDisplay_Request * msg = (mapviz_interfaces__srv__AddMapvizDisplay_Request *)malloc(sizeof(mapviz_interfaces__srv__AddMapvizDisplay_Request));
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(mapviz_interfaces__srv__AddMapvizDisplay_Request));
  bool success = mapviz_interfaces__srv__AddMapvizDisplay_Request__init(msg);
  if (!success) {
    free(msg);
    return NULL;
  }
  return msg;
}

void
mapviz_interfaces__srv__AddMapvizDisplay_Request__destroy(mapviz_interfaces__srv__AddMapvizDisplay_Request * msg)
{
  if (msg) {
    mapviz_interfaces__srv__AddMapvizDisplay_Request__fini(msg);
  }
  free(msg);
}


bool
mapviz_interfaces__srv__AddMapvizDisplay_Request__Sequence__init(mapviz_interfaces__srv__AddMapvizDisplay_Request__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  mapviz_interfaces__srv__AddMapvizDisplay_Request * data = NULL;
  if (size) {
    data = (mapviz_interfaces__srv__AddMapvizDisplay_Request *)calloc(size, sizeof(mapviz_interfaces__srv__AddMapvizDisplay_Request));
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = mapviz_interfaces__srv__AddMapvizDisplay_Request__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        mapviz_interfaces__srv__AddMapvizDisplay_Request__fini(&data[i - 1]);
      }
      free(data);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
mapviz_interfaces__srv__AddMapvizDisplay_Request__Sequence__fini(mapviz_interfaces__srv__AddMapvizDisplay_Request__Sequence * array)
{
  if (!array) {
    return;
  }
  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      mapviz_interfaces__srv__AddMapvizDisplay_Request__fini(&array->data[i]);
    }
    free(array->data);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

mapviz_interfaces__srv__AddMapvizDisplay_Request__Sequence *
mapviz_interfaces__srv__AddMapvizDisplay_Request__Sequence__create(size_t size)
{
  mapviz_interfaces__srv__AddMapvizDisplay_Request__Sequence * array = (mapviz_interfaces__srv__AddMapvizDisplay_Request__Sequence *)malloc(sizeof(mapviz_interfaces__srv__AddMapvizDisplay_Request__Sequence));
  if (!array) {
    return NULL;
  }
  bool success = mapviz_interfaces__srv__AddMapvizDisplay_Request__Sequence__init(array, size);
  if (!success) {
    free(array);
    return NULL;
  }
  return array;
}

void
mapviz_interfaces__srv__AddMapvizDisplay_Request__Sequence__destroy(mapviz_interfaces__srv__AddMapvizDisplay_Request__Sequence * array)
{
  if (array) {
    mapviz_interfaces__srv__AddMapvizDisplay_Request__Sequence__fini(array);
  }
  free(array);
}


// Include directives for member types
// Member `message`
// already included above
// #include "rosidl_generator_c/string_functions.h"

bool
mapviz_interfaces__srv__AddMapvizDisplay_Response__init(mapviz_interfaces__srv__AddMapvizDisplay_Response * msg)
{
  if (!msg) {
    return false;
  }
  // success
  // message
  if (!rosidl_generator_c__String__init(&msg->message)) {
    mapviz_interfaces__srv__AddMapvizDisplay_Response__fini(msg);
    return false;
  }
  return true;
}

void
mapviz_interfaces__srv__AddMapvizDisplay_Response__fini(mapviz_interfaces__srv__AddMapvizDisplay_Response * msg)
{
  if (!msg) {
    return;
  }
  // success
  // message
  rosidl_generator_c__String__fini(&msg->message);
}

mapviz_interfaces__srv__AddMapvizDisplay_Response *
mapviz_interfaces__srv__AddMapvizDisplay_Response__create()
{
  mapviz_interfaces__srv__AddMapvizDisplay_Response * msg = (mapviz_interfaces__srv__AddMapvizDisplay_Response *)malloc(sizeof(mapviz_interfaces__srv__AddMapvizDisplay_Response));
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(mapviz_interfaces__srv__AddMapvizDisplay_Response));
  bool success = mapviz_interfaces__srv__AddMapvizDisplay_Response__init(msg);
  if (!success) {
    free(msg);
    return NULL;
  }
  return msg;
}

void
mapviz_interfaces__srv__AddMapvizDisplay_Response__destroy(mapviz_interfaces__srv__AddMapvizDisplay_Response * msg)
{
  if (msg) {
    mapviz_interfaces__srv__AddMapvizDisplay_Response__fini(msg);
  }
  free(msg);
}


bool
mapviz_interfaces__srv__AddMapvizDisplay_Response__Sequence__init(mapviz_interfaces__srv__AddMapvizDisplay_Response__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  mapviz_interfaces__srv__AddMapvizDisplay_Response * data = NULL;
  if (size) {
    data = (mapviz_interfaces__srv__AddMapvizDisplay_Response *)calloc(size, sizeof(mapviz_interfaces__srv__AddMapvizDisplay_Response));
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = mapviz_interfaces__srv__AddMapvizDisplay_Response__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        mapviz_interfaces__srv__AddMapvizDisplay_Response__fini(&data[i - 1]);
      }
      free(data);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
mapviz_interfaces__srv__AddMapvizDisplay_Response__Sequence__fini(mapviz_interfaces__srv__AddMapvizDisplay_Response__Sequence * array)
{
  if (!array) {
    return;
  }
  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      mapviz_interfaces__srv__AddMapvizDisplay_Response__fini(&array->data[i]);
    }
    free(array->data);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

mapviz_interfaces__srv__AddMapvizDisplay_Response__Sequence *
mapviz_interfaces__srv__AddMapvizDisplay_Response__Sequence__create(size_t size)
{
  mapviz_interfaces__srv__AddMapvizDisplay_Response__Sequence * array = (mapviz_interfaces__srv__AddMapvizDisplay_Response__Sequence *)malloc(sizeof(mapviz_interfaces__srv__AddMapvizDisplay_Response__Sequence));
  if (!array) {
    return NULL;
  }
  bool success = mapviz_interfaces__srv__AddMapvizDisplay_Response__Sequence__init(array, size);
  if (!success) {
    free(array);
    return NULL;
  }
  return array;
}

void
mapviz_interfaces__srv__AddMapvizDisplay_Response__Sequence__destroy(mapviz_interfaces__srv__AddMapvizDisplay_Response__Sequence * array)
{
  if (array) {
    mapviz_interfaces__srv__AddMapvizDisplay_Response__Sequence__fini(array);
  }
  free(array);
}
