#ifndef _H_33FD00CE52F71BEEE50CFF00369EEED0_AddMapvizDisplay__H_
#define _H_33FD00CE52F71BEEE50CFF00369EEED0_AddMapvizDisplay__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"
#include "marti_common_msgs/msg/dds_opensplice/KeyValue_.h"


namespace mapviz_interfaces
{
    namespace srv
    {
        namespace dds_
        {
            struct  AddMapvizDisplay_Request_
            {
                struct _properties__seq_uniq_{};
                typedef DDS_DCPSUVLSeq< ::marti_common_msgs::msg::dds_::KeyValue_, struct _properties__seq_uniq_ > _properties__seq;
                typedef DDS_DCPSSequence_var< _properties__seq > _properties__seq_var;
                typedef DDS_DCPSSequence_out< _properties__seq > _properties__seq_out;
                ::DDS::String_mgr name_;
                ::DDS::String_mgr type_;
                ::DDS::Long draw_order_;
                ::DDS::Boolean visible_;
                _properties__seq properties_;
            };

            typedef DDS_DCPSStruct_var<AddMapvizDisplay_Request_> AddMapvizDisplay_Request__var;
            typedef DDS_DCPSStruct_out < AddMapvizDisplay_Request_> AddMapvizDisplay_Request__out;

            struct  AddMapvizDisplay_Response_
            {
                ::DDS::Boolean success_;
                ::DDS::String_mgr message_;
            };

            typedef DDS_DCPSStruct_var<AddMapvizDisplay_Response_> AddMapvizDisplay_Response__var;
            typedef DDS_DCPSStruct_out < AddMapvizDisplay_Response_> AddMapvizDisplay_Response__out;

            struct  Sample_AddMapvizDisplay_Request_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::mapviz_interfaces::srv::dds_::AddMapvizDisplay_Request_ request_;
            };

            typedef DDS_DCPSStruct_var<Sample_AddMapvizDisplay_Request_> Sample_AddMapvizDisplay_Request__var;
            typedef DDS_DCPSStruct_out < Sample_AddMapvizDisplay_Request_> Sample_AddMapvizDisplay_Request__out;

            struct  Sample_AddMapvizDisplay_Response_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::mapviz_interfaces::srv::dds_::AddMapvizDisplay_Response_ response_;
            };

            typedef DDS_DCPSStruct_var<Sample_AddMapvizDisplay_Response_> Sample_AddMapvizDisplay_Response__var;
            typedef DDS_DCPSStruct_out < Sample_AddMapvizDisplay_Response_> Sample_AddMapvizDisplay_Response__out;

        }

    }

}

#endif /* _H_33FD00CE52F71BEEE50CFF00369EEED0_AddMapvizDisplay__H_ */
