#ifndef _H_33FD00CE52F71BEEE50CFF00369EEED0_AddMapvizDisplay_DCPS_H_
#define _H_33FD00CE52F71BEEE50CFF00369EEED0_AddMapvizDisplay_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "AddMapvizDisplay_.h"


namespace mapviz_interfaces
{
    namespace srv
    {
        namespace dds_
        {
            class AddMapvizDisplay_Request_TypeSupportInterface;

            typedef AddMapvizDisplay_Request_TypeSupportInterface * AddMapvizDisplay_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < AddMapvizDisplay_Request_TypeSupportInterface> AddMapvizDisplay_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < AddMapvizDisplay_Request_TypeSupportInterface> AddMapvizDisplay_Request_TypeSupportInterface_out;


            class AddMapvizDisplay_Request_DataWriter;

            typedef AddMapvizDisplay_Request_DataWriter * AddMapvizDisplay_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < AddMapvizDisplay_Request_DataWriter> AddMapvizDisplay_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < AddMapvizDisplay_Request_DataWriter> AddMapvizDisplay_Request_DataWriter_out;


            class AddMapvizDisplay_Request_DataReader;

            typedef AddMapvizDisplay_Request_DataReader * AddMapvizDisplay_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < AddMapvizDisplay_Request_DataReader> AddMapvizDisplay_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < AddMapvizDisplay_Request_DataReader> AddMapvizDisplay_Request_DataReader_out;


            class AddMapvizDisplay_Request_DataReaderView;

            typedef AddMapvizDisplay_Request_DataReaderView * AddMapvizDisplay_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < AddMapvizDisplay_Request_DataReaderView> AddMapvizDisplay_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < AddMapvizDisplay_Request_DataReaderView> AddMapvizDisplay_Request_DataReaderView_out;

            struct AddMapvizDisplay_Request_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < AddMapvizDisplay_Request_, struct AddMapvizDisplay_Request_Seq_uniq_> AddMapvizDisplay_Request_Seq;
            typedef DDS_DCPSSequence_var < AddMapvizDisplay_Request_Seq> AddMapvizDisplay_Request_Seq_var;
            typedef DDS_DCPSSequence_out < AddMapvizDisplay_Request_Seq> AddMapvizDisplay_Request_Seq_out;

            class  AddMapvizDisplay_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef AddMapvizDisplay_Request_TypeSupportInterface_ptr _ptr_type;
                typedef AddMapvizDisplay_Request_TypeSupportInterface_var _var_type;

                static AddMapvizDisplay_Request_TypeSupportInterface_ptr _duplicate (AddMapvizDisplay_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static AddMapvizDisplay_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static AddMapvizDisplay_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static AddMapvizDisplay_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                AddMapvizDisplay_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                AddMapvizDisplay_Request_TypeSupportInterface () {};
                ~AddMapvizDisplay_Request_TypeSupportInterface () {};
            private:
                AddMapvizDisplay_Request_TypeSupportInterface (const AddMapvizDisplay_Request_TypeSupportInterface &);
                AddMapvizDisplay_Request_TypeSupportInterface & operator = (const AddMapvizDisplay_Request_TypeSupportInterface &);
            };

            class  AddMapvizDisplay_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef AddMapvizDisplay_Request_DataWriter_ptr _ptr_type;
                typedef AddMapvizDisplay_Request_DataWriter_var _var_type;

                static AddMapvizDisplay_Request_DataWriter_ptr _duplicate (AddMapvizDisplay_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static AddMapvizDisplay_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static AddMapvizDisplay_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static AddMapvizDisplay_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                AddMapvizDisplay_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const AddMapvizDisplay_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const AddMapvizDisplay_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const AddMapvizDisplay_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const AddMapvizDisplay_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const AddMapvizDisplay_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const AddMapvizDisplay_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const AddMapvizDisplay_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const AddMapvizDisplay_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const AddMapvizDisplay_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const AddMapvizDisplay_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (AddMapvizDisplay_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const AddMapvizDisplay_Request_& instance_data) = 0;

            protected:
                AddMapvizDisplay_Request_DataWriter () {};
                ~AddMapvizDisplay_Request_DataWriter () {};
            private:
                AddMapvizDisplay_Request_DataWriter (const AddMapvizDisplay_Request_DataWriter &);
                AddMapvizDisplay_Request_DataWriter & operator = (const AddMapvizDisplay_Request_DataWriter &);
            };

            class  AddMapvizDisplay_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef AddMapvizDisplay_Request_DataReader_ptr _ptr_type;
                typedef AddMapvizDisplay_Request_DataReader_var _var_type;

                static AddMapvizDisplay_Request_DataReader_ptr _duplicate (AddMapvizDisplay_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static AddMapvizDisplay_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static AddMapvizDisplay_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static AddMapvizDisplay_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                AddMapvizDisplay_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (AddMapvizDisplay_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (AddMapvizDisplay_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (AddMapvizDisplay_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (AddMapvizDisplay_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (AddMapvizDisplay_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (AddMapvizDisplay_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (AddMapvizDisplay_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (AddMapvizDisplay_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (AddMapvizDisplay_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (AddMapvizDisplay_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (AddMapvizDisplay_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (AddMapvizDisplay_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (AddMapvizDisplay_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (AddMapvizDisplay_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const AddMapvizDisplay_Request_& instance) = 0;

            protected:
                AddMapvizDisplay_Request_DataReader () {};
                ~AddMapvizDisplay_Request_DataReader () {};
            private:
                AddMapvizDisplay_Request_DataReader (const AddMapvizDisplay_Request_DataReader &);
                AddMapvizDisplay_Request_DataReader & operator = (const AddMapvizDisplay_Request_DataReader &);
            };

            class  AddMapvizDisplay_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef AddMapvizDisplay_Request_DataReaderView_ptr _ptr_type;
                typedef AddMapvizDisplay_Request_DataReaderView_var _var_type;

                static AddMapvizDisplay_Request_DataReaderView_ptr _duplicate (AddMapvizDisplay_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static AddMapvizDisplay_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static AddMapvizDisplay_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static AddMapvizDisplay_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                AddMapvizDisplay_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (AddMapvizDisplay_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (AddMapvizDisplay_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (AddMapvizDisplay_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (AddMapvizDisplay_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (AddMapvizDisplay_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (AddMapvizDisplay_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (AddMapvizDisplay_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (AddMapvizDisplay_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (AddMapvizDisplay_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (AddMapvizDisplay_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (AddMapvizDisplay_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (AddMapvizDisplay_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (AddMapvizDisplay_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (AddMapvizDisplay_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const AddMapvizDisplay_Request_& instance) = 0;

            protected:
                AddMapvizDisplay_Request_DataReaderView () {};
                ~AddMapvizDisplay_Request_DataReaderView () {};
            private:
                AddMapvizDisplay_Request_DataReaderView (const AddMapvizDisplay_Request_DataReaderView &);
                AddMapvizDisplay_Request_DataReaderView & operator = (const AddMapvizDisplay_Request_DataReaderView &);
            };
            class AddMapvizDisplay_Response_TypeSupportInterface;

            typedef AddMapvizDisplay_Response_TypeSupportInterface * AddMapvizDisplay_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < AddMapvizDisplay_Response_TypeSupportInterface> AddMapvizDisplay_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < AddMapvizDisplay_Response_TypeSupportInterface> AddMapvizDisplay_Response_TypeSupportInterface_out;


            class AddMapvizDisplay_Response_DataWriter;

            typedef AddMapvizDisplay_Response_DataWriter * AddMapvizDisplay_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < AddMapvizDisplay_Response_DataWriter> AddMapvizDisplay_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < AddMapvizDisplay_Response_DataWriter> AddMapvizDisplay_Response_DataWriter_out;


            class AddMapvizDisplay_Response_DataReader;

            typedef AddMapvizDisplay_Response_DataReader * AddMapvizDisplay_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < AddMapvizDisplay_Response_DataReader> AddMapvizDisplay_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < AddMapvizDisplay_Response_DataReader> AddMapvizDisplay_Response_DataReader_out;


            class AddMapvizDisplay_Response_DataReaderView;

            typedef AddMapvizDisplay_Response_DataReaderView * AddMapvizDisplay_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < AddMapvizDisplay_Response_DataReaderView> AddMapvizDisplay_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < AddMapvizDisplay_Response_DataReaderView> AddMapvizDisplay_Response_DataReaderView_out;

            struct AddMapvizDisplay_Response_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < AddMapvizDisplay_Response_, struct AddMapvizDisplay_Response_Seq_uniq_> AddMapvizDisplay_Response_Seq;
            typedef DDS_DCPSSequence_var < AddMapvizDisplay_Response_Seq> AddMapvizDisplay_Response_Seq_var;
            typedef DDS_DCPSSequence_out < AddMapvizDisplay_Response_Seq> AddMapvizDisplay_Response_Seq_out;

            class  AddMapvizDisplay_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef AddMapvizDisplay_Response_TypeSupportInterface_ptr _ptr_type;
                typedef AddMapvizDisplay_Response_TypeSupportInterface_var _var_type;

                static AddMapvizDisplay_Response_TypeSupportInterface_ptr _duplicate (AddMapvizDisplay_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static AddMapvizDisplay_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static AddMapvizDisplay_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static AddMapvizDisplay_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                AddMapvizDisplay_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                AddMapvizDisplay_Response_TypeSupportInterface () {};
                ~AddMapvizDisplay_Response_TypeSupportInterface () {};
            private:
                AddMapvizDisplay_Response_TypeSupportInterface (const AddMapvizDisplay_Response_TypeSupportInterface &);
                AddMapvizDisplay_Response_TypeSupportInterface & operator = (const AddMapvizDisplay_Response_TypeSupportInterface &);
            };

            class  AddMapvizDisplay_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef AddMapvizDisplay_Response_DataWriter_ptr _ptr_type;
                typedef AddMapvizDisplay_Response_DataWriter_var _var_type;

                static AddMapvizDisplay_Response_DataWriter_ptr _duplicate (AddMapvizDisplay_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static AddMapvizDisplay_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static AddMapvizDisplay_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static AddMapvizDisplay_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                AddMapvizDisplay_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const AddMapvizDisplay_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const AddMapvizDisplay_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const AddMapvizDisplay_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const AddMapvizDisplay_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const AddMapvizDisplay_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const AddMapvizDisplay_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const AddMapvizDisplay_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const AddMapvizDisplay_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const AddMapvizDisplay_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const AddMapvizDisplay_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (AddMapvizDisplay_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const AddMapvizDisplay_Response_& instance_data) = 0;

            protected:
                AddMapvizDisplay_Response_DataWriter () {};
                ~AddMapvizDisplay_Response_DataWriter () {};
            private:
                AddMapvizDisplay_Response_DataWriter (const AddMapvizDisplay_Response_DataWriter &);
                AddMapvizDisplay_Response_DataWriter & operator = (const AddMapvizDisplay_Response_DataWriter &);
            };

            class  AddMapvizDisplay_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef AddMapvizDisplay_Response_DataReader_ptr _ptr_type;
                typedef AddMapvizDisplay_Response_DataReader_var _var_type;

                static AddMapvizDisplay_Response_DataReader_ptr _duplicate (AddMapvizDisplay_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static AddMapvizDisplay_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static AddMapvizDisplay_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static AddMapvizDisplay_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                AddMapvizDisplay_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (AddMapvizDisplay_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (AddMapvizDisplay_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (AddMapvizDisplay_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (AddMapvizDisplay_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (AddMapvizDisplay_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (AddMapvizDisplay_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (AddMapvizDisplay_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (AddMapvizDisplay_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (AddMapvizDisplay_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (AddMapvizDisplay_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (AddMapvizDisplay_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (AddMapvizDisplay_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (AddMapvizDisplay_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (AddMapvizDisplay_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const AddMapvizDisplay_Response_& instance) = 0;

            protected:
                AddMapvizDisplay_Response_DataReader () {};
                ~AddMapvizDisplay_Response_DataReader () {};
            private:
                AddMapvizDisplay_Response_DataReader (const AddMapvizDisplay_Response_DataReader &);
                AddMapvizDisplay_Response_DataReader & operator = (const AddMapvizDisplay_Response_DataReader &);
            };

            class  AddMapvizDisplay_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef AddMapvizDisplay_Response_DataReaderView_ptr _ptr_type;
                typedef AddMapvizDisplay_Response_DataReaderView_var _var_type;

                static AddMapvizDisplay_Response_DataReaderView_ptr _duplicate (AddMapvizDisplay_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static AddMapvizDisplay_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static AddMapvizDisplay_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static AddMapvizDisplay_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                AddMapvizDisplay_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (AddMapvizDisplay_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (AddMapvizDisplay_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (AddMapvizDisplay_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (AddMapvizDisplay_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (AddMapvizDisplay_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (AddMapvizDisplay_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (AddMapvizDisplay_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (AddMapvizDisplay_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (AddMapvizDisplay_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (AddMapvizDisplay_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (AddMapvizDisplay_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (AddMapvizDisplay_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (AddMapvizDisplay_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (AddMapvizDisplay_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const AddMapvizDisplay_Response_& instance) = 0;

            protected:
                AddMapvizDisplay_Response_DataReaderView () {};
                ~AddMapvizDisplay_Response_DataReaderView () {};
            private:
                AddMapvizDisplay_Response_DataReaderView (const AddMapvizDisplay_Response_DataReaderView &);
                AddMapvizDisplay_Response_DataReaderView & operator = (const AddMapvizDisplay_Response_DataReaderView &);
            };
            class Sample_AddMapvizDisplay_Request_TypeSupportInterface;

            typedef Sample_AddMapvizDisplay_Request_TypeSupportInterface * Sample_AddMapvizDisplay_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_AddMapvizDisplay_Request_TypeSupportInterface> Sample_AddMapvizDisplay_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_AddMapvizDisplay_Request_TypeSupportInterface> Sample_AddMapvizDisplay_Request_TypeSupportInterface_out;


            class Sample_AddMapvizDisplay_Request_DataWriter;

            typedef Sample_AddMapvizDisplay_Request_DataWriter * Sample_AddMapvizDisplay_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_AddMapvizDisplay_Request_DataWriter> Sample_AddMapvizDisplay_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_AddMapvizDisplay_Request_DataWriter> Sample_AddMapvizDisplay_Request_DataWriter_out;


            class Sample_AddMapvizDisplay_Request_DataReader;

            typedef Sample_AddMapvizDisplay_Request_DataReader * Sample_AddMapvizDisplay_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_AddMapvizDisplay_Request_DataReader> Sample_AddMapvizDisplay_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_AddMapvizDisplay_Request_DataReader> Sample_AddMapvizDisplay_Request_DataReader_out;


            class Sample_AddMapvizDisplay_Request_DataReaderView;

            typedef Sample_AddMapvizDisplay_Request_DataReaderView * Sample_AddMapvizDisplay_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_AddMapvizDisplay_Request_DataReaderView> Sample_AddMapvizDisplay_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_AddMapvizDisplay_Request_DataReaderView> Sample_AddMapvizDisplay_Request_DataReaderView_out;

            struct Sample_AddMapvizDisplay_Request_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < Sample_AddMapvizDisplay_Request_, struct Sample_AddMapvizDisplay_Request_Seq_uniq_> Sample_AddMapvizDisplay_Request_Seq;
            typedef DDS_DCPSSequence_var < Sample_AddMapvizDisplay_Request_Seq> Sample_AddMapvizDisplay_Request_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_AddMapvizDisplay_Request_Seq> Sample_AddMapvizDisplay_Request_Seq_out;

            class  Sample_AddMapvizDisplay_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_AddMapvizDisplay_Request_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_AddMapvizDisplay_Request_TypeSupportInterface_var _var_type;

                static Sample_AddMapvizDisplay_Request_TypeSupportInterface_ptr _duplicate (Sample_AddMapvizDisplay_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_AddMapvizDisplay_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_AddMapvizDisplay_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_AddMapvizDisplay_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_AddMapvizDisplay_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_AddMapvizDisplay_Request_TypeSupportInterface () {};
                ~Sample_AddMapvizDisplay_Request_TypeSupportInterface () {};
            private:
                Sample_AddMapvizDisplay_Request_TypeSupportInterface (const Sample_AddMapvizDisplay_Request_TypeSupportInterface &);
                Sample_AddMapvizDisplay_Request_TypeSupportInterface & operator = (const Sample_AddMapvizDisplay_Request_TypeSupportInterface &);
            };

            class  Sample_AddMapvizDisplay_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_AddMapvizDisplay_Request_DataWriter_ptr _ptr_type;
                typedef Sample_AddMapvizDisplay_Request_DataWriter_var _var_type;

                static Sample_AddMapvizDisplay_Request_DataWriter_ptr _duplicate (Sample_AddMapvizDisplay_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_AddMapvizDisplay_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_AddMapvizDisplay_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_AddMapvizDisplay_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_AddMapvizDisplay_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_AddMapvizDisplay_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_AddMapvizDisplay_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_AddMapvizDisplay_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_AddMapvizDisplay_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_AddMapvizDisplay_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_AddMapvizDisplay_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_AddMapvizDisplay_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_AddMapvizDisplay_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_AddMapvizDisplay_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_AddMapvizDisplay_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_AddMapvizDisplay_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_AddMapvizDisplay_Request_& instance_data) = 0;

            protected:
                Sample_AddMapvizDisplay_Request_DataWriter () {};
                ~Sample_AddMapvizDisplay_Request_DataWriter () {};
            private:
                Sample_AddMapvizDisplay_Request_DataWriter (const Sample_AddMapvizDisplay_Request_DataWriter &);
                Sample_AddMapvizDisplay_Request_DataWriter & operator = (const Sample_AddMapvizDisplay_Request_DataWriter &);
            };

            class  Sample_AddMapvizDisplay_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_AddMapvizDisplay_Request_DataReader_ptr _ptr_type;
                typedef Sample_AddMapvizDisplay_Request_DataReader_var _var_type;

                static Sample_AddMapvizDisplay_Request_DataReader_ptr _duplicate (Sample_AddMapvizDisplay_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_AddMapvizDisplay_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_AddMapvizDisplay_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_AddMapvizDisplay_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_AddMapvizDisplay_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_AddMapvizDisplay_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_AddMapvizDisplay_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_AddMapvizDisplay_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_AddMapvizDisplay_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_AddMapvizDisplay_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_AddMapvizDisplay_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_AddMapvizDisplay_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_AddMapvizDisplay_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_AddMapvizDisplay_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_AddMapvizDisplay_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_AddMapvizDisplay_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_AddMapvizDisplay_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_AddMapvizDisplay_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_AddMapvizDisplay_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_AddMapvizDisplay_Request_& instance) = 0;

            protected:
                Sample_AddMapvizDisplay_Request_DataReader () {};
                ~Sample_AddMapvizDisplay_Request_DataReader () {};
            private:
                Sample_AddMapvizDisplay_Request_DataReader (const Sample_AddMapvizDisplay_Request_DataReader &);
                Sample_AddMapvizDisplay_Request_DataReader & operator = (const Sample_AddMapvizDisplay_Request_DataReader &);
            };

            class  Sample_AddMapvizDisplay_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_AddMapvizDisplay_Request_DataReaderView_ptr _ptr_type;
                typedef Sample_AddMapvizDisplay_Request_DataReaderView_var _var_type;

                static Sample_AddMapvizDisplay_Request_DataReaderView_ptr _duplicate (Sample_AddMapvizDisplay_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_AddMapvizDisplay_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_AddMapvizDisplay_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_AddMapvizDisplay_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_AddMapvizDisplay_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_AddMapvizDisplay_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_AddMapvizDisplay_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_AddMapvizDisplay_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_AddMapvizDisplay_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_AddMapvizDisplay_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_AddMapvizDisplay_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_AddMapvizDisplay_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_AddMapvizDisplay_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_AddMapvizDisplay_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_AddMapvizDisplay_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_AddMapvizDisplay_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_AddMapvizDisplay_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_AddMapvizDisplay_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_AddMapvizDisplay_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_AddMapvizDisplay_Request_& instance) = 0;

            protected:
                Sample_AddMapvizDisplay_Request_DataReaderView () {};
                ~Sample_AddMapvizDisplay_Request_DataReaderView () {};
            private:
                Sample_AddMapvizDisplay_Request_DataReaderView (const Sample_AddMapvizDisplay_Request_DataReaderView &);
                Sample_AddMapvizDisplay_Request_DataReaderView & operator = (const Sample_AddMapvizDisplay_Request_DataReaderView &);
            };
            class Sample_AddMapvizDisplay_Response_TypeSupportInterface;

            typedef Sample_AddMapvizDisplay_Response_TypeSupportInterface * Sample_AddMapvizDisplay_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_AddMapvizDisplay_Response_TypeSupportInterface> Sample_AddMapvizDisplay_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_AddMapvizDisplay_Response_TypeSupportInterface> Sample_AddMapvizDisplay_Response_TypeSupportInterface_out;


            class Sample_AddMapvizDisplay_Response_DataWriter;

            typedef Sample_AddMapvizDisplay_Response_DataWriter * Sample_AddMapvizDisplay_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_AddMapvizDisplay_Response_DataWriter> Sample_AddMapvizDisplay_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_AddMapvizDisplay_Response_DataWriter> Sample_AddMapvizDisplay_Response_DataWriter_out;


            class Sample_AddMapvizDisplay_Response_DataReader;

            typedef Sample_AddMapvizDisplay_Response_DataReader * Sample_AddMapvizDisplay_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_AddMapvizDisplay_Response_DataReader> Sample_AddMapvizDisplay_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_AddMapvizDisplay_Response_DataReader> Sample_AddMapvizDisplay_Response_DataReader_out;


            class Sample_AddMapvizDisplay_Response_DataReaderView;

            typedef Sample_AddMapvizDisplay_Response_DataReaderView * Sample_AddMapvizDisplay_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_AddMapvizDisplay_Response_DataReaderView> Sample_AddMapvizDisplay_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_AddMapvizDisplay_Response_DataReaderView> Sample_AddMapvizDisplay_Response_DataReaderView_out;

            struct Sample_AddMapvizDisplay_Response_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < Sample_AddMapvizDisplay_Response_, struct Sample_AddMapvizDisplay_Response_Seq_uniq_> Sample_AddMapvizDisplay_Response_Seq;
            typedef DDS_DCPSSequence_var < Sample_AddMapvizDisplay_Response_Seq> Sample_AddMapvizDisplay_Response_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_AddMapvizDisplay_Response_Seq> Sample_AddMapvizDisplay_Response_Seq_out;

            class  Sample_AddMapvizDisplay_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_AddMapvizDisplay_Response_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_AddMapvizDisplay_Response_TypeSupportInterface_var _var_type;

                static Sample_AddMapvizDisplay_Response_TypeSupportInterface_ptr _duplicate (Sample_AddMapvizDisplay_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_AddMapvizDisplay_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_AddMapvizDisplay_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_AddMapvizDisplay_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_AddMapvizDisplay_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_AddMapvizDisplay_Response_TypeSupportInterface () {};
                ~Sample_AddMapvizDisplay_Response_TypeSupportInterface () {};
            private:
                Sample_AddMapvizDisplay_Response_TypeSupportInterface (const Sample_AddMapvizDisplay_Response_TypeSupportInterface &);
                Sample_AddMapvizDisplay_Response_TypeSupportInterface & operator = (const Sample_AddMapvizDisplay_Response_TypeSupportInterface &);
            };

            class  Sample_AddMapvizDisplay_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_AddMapvizDisplay_Response_DataWriter_ptr _ptr_type;
                typedef Sample_AddMapvizDisplay_Response_DataWriter_var _var_type;

                static Sample_AddMapvizDisplay_Response_DataWriter_ptr _duplicate (Sample_AddMapvizDisplay_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_AddMapvizDisplay_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_AddMapvizDisplay_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_AddMapvizDisplay_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_AddMapvizDisplay_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_AddMapvizDisplay_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_AddMapvizDisplay_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_AddMapvizDisplay_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_AddMapvizDisplay_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_AddMapvizDisplay_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_AddMapvizDisplay_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_AddMapvizDisplay_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_AddMapvizDisplay_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_AddMapvizDisplay_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_AddMapvizDisplay_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_AddMapvizDisplay_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_AddMapvizDisplay_Response_& instance_data) = 0;

            protected:
                Sample_AddMapvizDisplay_Response_DataWriter () {};
                ~Sample_AddMapvizDisplay_Response_DataWriter () {};
            private:
                Sample_AddMapvizDisplay_Response_DataWriter (const Sample_AddMapvizDisplay_Response_DataWriter &);
                Sample_AddMapvizDisplay_Response_DataWriter & operator = (const Sample_AddMapvizDisplay_Response_DataWriter &);
            };

            class  Sample_AddMapvizDisplay_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_AddMapvizDisplay_Response_DataReader_ptr _ptr_type;
                typedef Sample_AddMapvizDisplay_Response_DataReader_var _var_type;

                static Sample_AddMapvizDisplay_Response_DataReader_ptr _duplicate (Sample_AddMapvizDisplay_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_AddMapvizDisplay_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_AddMapvizDisplay_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_AddMapvizDisplay_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_AddMapvizDisplay_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_AddMapvizDisplay_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_AddMapvizDisplay_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_AddMapvizDisplay_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_AddMapvizDisplay_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_AddMapvizDisplay_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_AddMapvizDisplay_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_AddMapvizDisplay_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_AddMapvizDisplay_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_AddMapvizDisplay_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_AddMapvizDisplay_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_AddMapvizDisplay_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_AddMapvizDisplay_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_AddMapvizDisplay_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_AddMapvizDisplay_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_AddMapvizDisplay_Response_& instance) = 0;

            protected:
                Sample_AddMapvizDisplay_Response_DataReader () {};
                ~Sample_AddMapvizDisplay_Response_DataReader () {};
            private:
                Sample_AddMapvizDisplay_Response_DataReader (const Sample_AddMapvizDisplay_Response_DataReader &);
                Sample_AddMapvizDisplay_Response_DataReader & operator = (const Sample_AddMapvizDisplay_Response_DataReader &);
            };

            class  Sample_AddMapvizDisplay_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_AddMapvizDisplay_Response_DataReaderView_ptr _ptr_type;
                typedef Sample_AddMapvizDisplay_Response_DataReaderView_var _var_type;

                static Sample_AddMapvizDisplay_Response_DataReaderView_ptr _duplicate (Sample_AddMapvizDisplay_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_AddMapvizDisplay_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_AddMapvizDisplay_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_AddMapvizDisplay_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_AddMapvizDisplay_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_AddMapvizDisplay_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_AddMapvizDisplay_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_AddMapvizDisplay_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_AddMapvizDisplay_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_AddMapvizDisplay_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_AddMapvizDisplay_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_AddMapvizDisplay_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_AddMapvizDisplay_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_AddMapvizDisplay_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_AddMapvizDisplay_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_AddMapvizDisplay_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_AddMapvizDisplay_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_AddMapvizDisplay_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_AddMapvizDisplay_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_AddMapvizDisplay_Response_& instance) = 0;

            protected:
                Sample_AddMapvizDisplay_Response_DataReaderView () {};
                ~Sample_AddMapvizDisplay_Response_DataReaderView () {};
            private:
                Sample_AddMapvizDisplay_Response_DataReaderView (const Sample_AddMapvizDisplay_Response_DataReaderView &);
                Sample_AddMapvizDisplay_Response_DataReaderView & operator = (const Sample_AddMapvizDisplay_Response_DataReaderView &);
            };
        }

    }

}

#endif
